// $ANTLR 2.7.4: "assert.g" -> "AssertLexer.java"$

/*
 * Copyright (c) 2000
 *      Jon Schewe.  All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * I'd appreciate comments/suggestions on the code jpschewe@mtu.net
 */
package net.mtu.eggplant.dbc;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.CharScanner;
import antlr.InputBuffer;
import antlr.ByteBuffer;
import antlr.CharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

public class AssertLexer extends antlr.CharScanner implements AssertLexerTokenTypes, TokenStream
 {


  private static final Log LOG = LogFactory.getLog(AssertLexer.class);
public AssertLexer(InputStream in) {
	this(new ByteBuffer(in));
}
public AssertLexer(Reader in) {
	this(new CharBuffer(in));
}
public AssertLexer(InputBuffer ib) {
	this(new LexerSharedInputState(ib));
}
public AssertLexer(LexerSharedInputState state) {
	super(state);
	caseSensitiveLiterals = true;
	setCaseSensitive(true);
	literals = new Hashtable();
	literals.put(new ANTLRHashString("byte", this), new Integer(56));
	literals.put(new ANTLRHashString("public", this), new Integer(67));
	literals.put(new ANTLRHashString("case", this), new Integer(97));
	literals.put(new ANTLRHashString("short", this), new Integer(58));
	literals.put(new ANTLRHashString("break", this), new Integer(92));
	literals.put(new ANTLRHashString("while", this), new Integer(90));
	literals.put(new ANTLRHashString("new", this), new Integer(142));
	literals.put(new ANTLRHashString("instanceof", this), new Integer(125));
	literals.put(new ANTLRHashString("implements", this), new Integer(81));
	literals.put(new ANTLRHashString("synchronized", this), new Integer(73));
	literals.put(new ANTLRHashString("float", this), new Integer(60));
	literals.put(new ANTLRHashString("package", this), new Integer(49));
	literals.put(new ANTLRHashString("return", this), new Integer(94));
	literals.put(new ANTLRHashString("throw", this), new Integer(96));
	literals.put(new ANTLRHashString("null", this), new Integer(141));
	literals.put(new ANTLRHashString("threadsafe", this), new Integer(72));
	literals.put(new ANTLRHashString("protected", this), new Integer(68));
	literals.put(new ANTLRHashString("class", this), new Integer(75));
	literals.put(new ANTLRHashString("throws", this), new Integer(85));
	literals.put(new ANTLRHashString("do", this), new Integer(91));
	literals.put(new ANTLRHashString("super", this), new Integer(138));
	literals.put(new ANTLRHashString("transient", this), new Integer(70));
	literals.put(new ANTLRHashString("native", this), new Integer(71));
	literals.put(new ANTLRHashString("interface", this), new Integer(77));
	literals.put(new ANTLRHashString("final", this), new Integer(39));
	literals.put(new ANTLRHashString("if", this), new Integer(87));
	literals.put(new ANTLRHashString("double", this), new Integer(62));
	literals.put(new ANTLRHashString("volatile", this), new Integer(74));
	literals.put(new ANTLRHashString("catch", this), new Integer(101));
	literals.put(new ANTLRHashString("try", this), new Integer(99));
	literals.put(new ANTLRHashString("int", this), new Integer(59));
	literals.put(new ANTLRHashString("for", this), new Integer(89));
	literals.put(new ANTLRHashString("extends", this), new Integer(76));
	literals.put(new ANTLRHashString("boolean", this), new Integer(55));
	literals.put(new ANTLRHashString("char", this), new Integer(57));
	literals.put(new ANTLRHashString("private", this), new Integer(66));
	literals.put(new ANTLRHashString("default", this), new Integer(98));
	literals.put(new ANTLRHashString("false", this), new Integer(140));
	literals.put(new ANTLRHashString("this", this), new Integer(137));
	literals.put(new ANTLRHashString("static", this), new Integer(69));
	literals.put(new ANTLRHashString("abstract", this), new Integer(40));
	literals.put(new ANTLRHashString("continue", this), new Integer(93));
	literals.put(new ANTLRHashString("finally", this), new Integer(100));
	literals.put(new ANTLRHashString("else", this), new Integer(88));
	literals.put(new ANTLRHashString("import", this), new Integer(51));
	literals.put(new ANTLRHashString("void", this), new Integer(54));
	literals.put(new ANTLRHashString("switch", this), new Integer(95));
	literals.put(new ANTLRHashString("true", this), new Integer(139));
	literals.put(new ANTLRHashString("long", this), new Integer(61));
}

public Token nextToken() throws TokenStreamException {
	Token theRetToken=null;
tryAgain:
	for (;;) {
		Token _token = null;
		int _ttype = Token.INVALID_TYPE;
		setCommitToPath(false);
		resetText();
		try {   // for char stream error handling
			try {   // for lexical error handling
				if ((LA(1)=='@') && (LA(2)=='p') && (LA(3)=='o')) {
					mPOST_CONDITION(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='@') && (LA(2)=='p') && (LA(3)=='r')) {
					mPRE_CONDITION(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='@') && (LA(2)=='a')) {
					mASSERT_CONDITION(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='@') && (LA(2)=='i')) {
					mINVARIANT_CONDITION(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='*') && (LA(2)=='/')) {
					mJAVADOC_CLOSE(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='\n'||LA(1)=='\r')) {
					mNEWLINE(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1)=='*') && (true)) {
					mSTAR_TEXT(true);
					theRetToken=_returnToken;
				}
				else {
					if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
				else {consume(); continue tryAgain;}
				}
				
				if ( _returnToken==null ) continue tryAgain; // found SKIP token
				_ttype = _returnToken.getType();
				_returnToken.setType(_ttype);
				return _returnToken;
			}
			catch (RecognitionException e) {
				if ( !getCommitToPath() ) {consume(); continue tryAgain;}
				throw new TokenStreamRecognitionException(e);
			}
		}
		catch (CharStreamException cse) {
			if ( cse instanceof CharStreamIOException ) {
				throw new TokenStreamIOException(((CharStreamIOException)cse).io);
			}
			else {
				throw new TokenStreamException(cse.getMessage());
			}
		}
	}
}

	protected final void mVOCAB(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = VOCAB;
		int _saveIndex;
		
		matchRange('\3','\377');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mNEWLINE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NEWLINE;
		int _saveIndex;
		
		{
		if ((LA(1)=='\r') && (LA(2)=='\n')) {
			match('\r');
			match('\n');
		}
		else if ((LA(1)=='\n')) {
			match('\n');
		}
		else if ((LA(1)=='\r') && (true)) {
			match('\r');
		}
		else {
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		
		newline();
		_ttype = Token.SKIP;
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mCONDITION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = CONDITION;
		int _saveIndex;
		int count = 0;
		
		match('(');
		{
		int _cnt7=0;
		_loop7:
		do {
			switch ( LA(1)) {
			case '(':
			{
				match('(');
				count++;
				break;
			}
			case '\n':
			{
				match('\n');
				newline();
				break;
			}
			default:
				if ((LA(1)=='\r') && (LA(2)=='\n') && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true)) {
					match('\r');
					match('\n');
					newline();
				}
				else if (((LA(1)==')') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true))&&( count > 0 )) {
					match(')');
					count--;
				}
				else if ((LA(1)=='\r') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true)) {
					match('\r');
					newline();
				}
				else if ((_tokenSet_0.member(LA(1)))) {
					{
					match(_tokenSet_0);
					}
				}
			else {
				if ( _cnt7>=1 ) { break _loop7; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			}
			_cnt7++;
		} while (true);
		}
		match(')');
		LOG.debug("Assert: got CONDITION #" + text + "#");
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mCOMMA(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = COMMA;
		int _saveIndex;
		
		match(',');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mSEMI(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SEMI;
		int _saveIndex;
		
		match(';');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mSTRING_LITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = STRING_LITERAL;
		int _saveIndex;
		
		match('"');
		{
		_loop13:
		do {
			if ((LA(1)=='\\')) {
				mESC(false);
			}
			else if ((_tokenSet_1.member(LA(1)))) {
				{
				match(_tokenSet_1);
				}
			}
			else {
				break _loop13;
			}
			
		} while (true);
		}
		match('"');
		LOG.debug("Assert: got MESSAGE #" + text + "#");
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mESC(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = ESC;
		int _saveIndex;
		
		match('\\');
		{
		switch ( LA(1)) {
		case 'n':
		{
			match('n');
			break;
		}
		case 'r':
		{
			match('r');
			break;
		}
		case 't':
		{
			match('t');
			break;
		}
		case 'b':
		{
			match('b');
			break;
		}
		case 'f':
		{
			match('f');
			break;
		}
		case '"':
		{
			match('"');
			break;
		}
		case '\'':
		{
			match('\'');
			break;
		}
		case '\\':
		{
			match('\\');
			break;
		}
		case 'u':
		{
			{
			int _cnt43=0;
			_loop43:
			do {
				if ((LA(1)=='u')) {
					match('u');
				}
				else {
					if ( _cnt43>=1 ) { break _loop43; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				
				_cnt43++;
			} while (true);
			}
			mHEX_DIGIT(false);
			mHEX_DIGIT(false);
			mHEX_DIGIT(false);
			mHEX_DIGIT(false);
			break;
		}
		case '0':  case '1':  case '2':  case '3':
		{
			{
			matchRange('0','3');
			}
			{
			if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true)) {
				{
				matchRange('0','9');
				}
				{
				if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true)) {
					matchRange('0','9');
				}
				else if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true)) {
				}
				else {
					throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				
				}
			}
			else if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true)) {
			}
			else {
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
			break;
		}
		case '4':  case '5':  case '6':  case '7':
		{
			{
			matchRange('4','7');
			}
			{
			if (((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true)) {
				{
				matchRange('0','9');
				}
			}
			else if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true)) {
			}
			else {
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mSPACE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SPACE;
		int _saveIndex;
		
		{
		switch ( LA(1)) {
		case ' ':
		{
			match(' ');
			break;
		}
		case '\t':
		{
			match('\t');
			break;
		}
		case '\u000c':
		{
			match('\f');
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mPOST_CONDITION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = POST_CONDITION;
		int _saveIndex;
		Token cond=null;
		Token mesg=null;
		
		String c = null;
		String m = null;
		
		
		match("@post");
		{
		_loop18:
		do {
			if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
				mSPACE(false);
			}
			else {
				break _loop18;
			}
			
		} while (true);
		}
		mCONDITION(true);
		cond=_returnToken;
		c = cond.getText();
		{
		if ((LA(1)==',')) {
			mCOMMA(false);
			{
			_loop21:
			do {
				if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
					mSPACE(false);
				}
				else {
					break _loop21;
				}
				
			} while (true);
			}
			mSTRING_LITERAL(true);
			mesg=_returnToken;
			m = mesg.getText();
			mSEMI(false);
		}
		else {
		}
		
		}
		
		if(c != null) {
		//        c = c.replace('\n', ' ');
		//        c = c.replace('\r', ' ');
		AssertToken assertTok = new AssertToken(c, m, _ttype, new String(text.getBuffer(),_begin,text.length()-_begin));
		_token = assertTok;
		} else {
		_ttype = Token.SKIP;
		}
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mPRE_CONDITION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = PRE_CONDITION;
		int _saveIndex;
		Token cond=null;
		Token mesg=null;
		
		String c = null;
		String m = null;
		
		
		match("@pre");
		{
		_loop24:
		do {
			if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
				mSPACE(false);
			}
			else {
				break _loop24;
			}
			
		} while (true);
		}
		mCONDITION(true);
		cond=_returnToken;
		c = cond.getText();
		{
		if ((LA(1)==',')) {
			mCOMMA(false);
			{
			_loop27:
			do {
				if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
					mSPACE(false);
				}
				else {
					break _loop27;
				}
				
			} while (true);
			}
			mSTRING_LITERAL(true);
			mesg=_returnToken;
			m = mesg.getText();
			mSEMI(false);
		}
		else {
		}
		
		}
		
		if(c != null) {
		//        c = c.replace('\n', ' ');
		//        c = c.replace('\r', ' ');
		final AssertToken assertTok = new AssertToken(c, m, _ttype, new String(text.getBuffer(),_begin,text.length()-_begin));
		_token = assertTok;
		} else {
		_ttype = Token.SKIP;
		}
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mASSERT_CONDITION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = ASSERT_CONDITION;
		int _saveIndex;
		Token cond=null;
		Token mesg=null;
		
		String c = null;
		String m = null;
		
		
		match("@assert");
		{
		_loop30:
		do {
			if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
				mSPACE(false);
			}
			else {
				break _loop30;
			}
			
		} while (true);
		}
		mCONDITION(true);
		cond=_returnToken;
		c = cond.getText();
		{
		if ((LA(1)==',')) {
			mCOMMA(false);
			{
			_loop33:
			do {
				if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
					mSPACE(false);
				}
				else {
					break _loop33;
				}
				
			} while (true);
			}
			mSTRING_LITERAL(true);
			mesg=_returnToken;
			m = mesg.getText();
			mSEMI(false);
		}
		else {
		}
		
		}
		
		if(c != null) {
		//        c = c.replace('\n', ' ');
		//        c = c.replace('\r', ' ');
		AssertToken assertTok = new AssertToken(c, m, _ttype, new String(text.getBuffer(),_begin,text.length()-_begin));
		_token = assertTok;
		} else {
		_ttype = Token.SKIP;
		}
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mINVARIANT_CONDITION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = INVARIANT_CONDITION;
		int _saveIndex;
		Token cond=null;
		Token mesg=null;
		
		String c = null;
		String m = null;
		
		
		match("@invariant");
		{
		_loop36:
		do {
			if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
				mSPACE(false);
			}
			else {
				break _loop36;
			}
			
		} while (true);
		}
		mCONDITION(true);
		cond=_returnToken;
		c = cond.getText();
		{
		if ((LA(1)==',')) {
			mCOMMA(false);
			{
			_loop39:
			do {
				if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
					mSPACE(false);
				}
				else {
					break _loop39;
				}
				
			} while (true);
			}
			mSTRING_LITERAL(true);
			mesg=_returnToken;
			m = mesg.getText();
			mSEMI(false);
		}
		else {
		}
		
		}
		
		if(c != null) {
		//        c = c.replace('\n', ' ');
		//        c = c.replace('\r', ' ');
		AssertToken assertTok = new AssertToken(c, m, _ttype, new String(text.getBuffer(),_begin,text.length()-_begin));
		_token = assertTok;
		} else {
		_ttype = Token.SKIP;
		}
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mHEX_DIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = HEX_DIGIT;
		int _saveIndex;
		
		{
		switch ( LA(1)) {
		case '0':  case '1':  case '2':  case '3':
		case '4':  case '5':  case '6':  case '7':
		case '8':  case '9':
		{
			matchRange('0','9');
			break;
		}
		case 'A':  case 'B':  case 'C':  case 'D':
		case 'E':  case 'F':
		{
			matchRange('A','F');
			break;
		}
		case 'a':  case 'b':  case 'c':  case 'd':
		case 'e':  case 'f':
		{
			matchRange('a','f');
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mSTAR_TEXT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = STAR_TEXT;
		int _saveIndex;
		
		{
		int _cnt55=0;
		_loop55:
		do {
			if (((LA(1)=='*'))&&( LA(2) !='/' )) {
				match('*');
			}
			else {
				if ( _cnt55>=1 ) { break _loop55; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			_cnt55++;
		} while (true);
		}
		
		_ttype = Token.SKIP;
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mJAVADOC_CLOSE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = JAVADOC_CLOSE;
		int _saveIndex;
		
		match("*/");
		
		LOG.debug("Assert: got end of javadoc comment #" + text + "#");
		JonsAssert.getSelector().pop();
		//JonsAssert.selector.push(JonsAssert.javaLexer);
		
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	
	private static final long[] mk_tokenSet_0() {
		long[] data = new long[8];
		data[0]=-3298534892552L;
		for (int i = 1; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = new long[8];
		data[0]=-17179869192L;
		data[1]=-268435457L;
		for (int i = 2; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	
	}
